'------------------------------------------------------------------------
'  Gameplanet.vbs (v1.41)
'------------------------------------------------------------------------
'
' This script retreives game-related news from www.gameplanet.co.nz
'
' It also retreives news images (screenshots, logos etc) for display
' in Samurize.
'
' Try the example config file included for more information.
'
'
' Version history:
' ================
'
' v1.41:- fixed images (article layout slightly changed)
'
' v1.4: - added images
'         * use the GetImage function to display images using the Samurize
'           Image Display Type. NewsItemNumber is the number of the news
'           item you wish to display an image for.
'
' v1.3: - hid some functions from Samurize
'	- added function that uses a tempfile gameplanet_news.txt
'         (useful for TextFile meters and my Text Cycler script)
'
' v1.2: - rewrote the script for Samurize 0.81a - eliminated the need for
'	  a temp file thanks to line feed in Samurize fields
'
' v1.1:	- fixed garbled news items generated when a 'comment' link is 
'	  under a news item
' 					                       - NeM 
'------------------------------------------------------------------------

' ======================================================
' Path to your Samurize directory
' Any files created by the script will be placed here
SAMURIZE_DIR = "C:/Program Files/Samurize/"
' ======================================================

Function GetImage(NewsItemNumber)
    GetImage = SAMURIZE_DIR & "gameplanet" & NewsItemNumber & ".jpeg"
End Function

Function GetNews(numNewsItems)		

	dim htmlResult,fs,f,output,newsTitle,fileName
	htmlResult = ReturnHTML("http://www.gameplanet.co.nz")
	output = NULL

	relnext = instr(htmlResult, "<!-- News -->")

	if relnext > 0 then
		for i = 1 to numNewsItems

			leftPos = instr( relnext, htmlResult, "a name=""article") 	'strip <b>
			rightPos = instr( leftPos, htmlResult, "</b>") 			'until </b>
			relnext = rightPos+4 						'next item

			if leftPos > 0 AND rightPos > leftPos Then
				'grab the name of the news item
				newsTitle = right(mid( htmlResult, leftPos+1, rightPos-leftPos-1 ), rightPos-leftPos-24)
			end if

			'append the news item to the list and put a newline char after it
			output = output & newsTitle

			' don't add a newline to the last news item
			If i < numNewsItems Then
				output = output & (Chr(13) & Chr(10))
			End If
                        
                        ' do images
                        FileName = SAMURIZE_DIR & "gameplanet" & i & ".jpeg"
                        'imagePos = instr( leftPos, htmlResult, "src=""http://")
                        imagePos = instr (leftPos, htmlResult, "src=""/images/mag/")
                        nextArticlePos = instr( relnext, htmlResult, "a name=""article")
                        
                        if (imagePos > 0) and (imagePos < nextArticlePos) Then
                            imageEndPos = InStr ( imagePos+5, htmlResult, """") - 1
                            imageUrl = "http://www.gameplanet.co.nz/" & mid(htmlResult, imagePos+5, imageEndPos - imagePos-4) 
                            saveImage imageURL, filename
                        Else
                            ' no available image - delete it if it exists
                            dim filesys, demofile
                            set filesys = CreateObject ("Scripting.FileSystemObject")
                            set demofile = filesys.CreateTextFile (filename, true)
                            set demofile = filesys.GetFile(filename)
                            demofile.Delete
                        End If

		next
	end if

	GetNews = output
End Function

Function getNewsTempFile(numNewsItems)

	set fs=CreateObject("Scripting.FileSystemObject")
	set f=fs.CreateTextFile(SAMURIZE_DIR & "gameplanet_news.txt",true)
	f.write(GetNews(numNewsItems))
	f.close
	set f=nothing
	set fs=nothing

	getNewsTempFile = "OK"

End Function

Private Function SaveImage(imageURL, fileName)
    'Thanks to clarence for posting this section in the Forums, very helpful	     
    Dim Http
    Set Http = CreateObject("Microsoft.XMLHTTP")

    Http.Open "GET", imageURL, False
    Http.Send
    BinaryGetURL = Http.ResponseBody

    Dim BinaryStream
    Set BinaryStream = CreateObject("ADODB.Stream")
    
    BinaryStream.Type = 1
    BinaryStream.Open
    BinaryStream.Write BinaryGetURL
    BinaryStream.SaveToFile fileName, 2
End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
End Function
